plugins['presencepause'] = (function() {

    var enable_pause_monitor = pluginconfig['presencepause']?.enable_pause_monitor?.[''] || 0;
    return { 

        loadLang: function(values) {
        },
        setLang: function() {
        },
        init: function() {
            if(this.queuepause_permitted()) {
                $('.navinputpresence').show();
            } else {
                $('.navinputpresence').hide();
            }
        },
        queuepause_permitted: function() {
            if(
                (!hasPerm(0,'queuepause') && !hasPerm(0,'queueagent') && !hasPerm(0,'queuemanager') && !hasPerm(0,'all')) &&
                (!hasPerm(myposition,'queuepause') && !hasPerm(myposition,'queueagent') && !hasPerm(myposition,'queuemanager') && !hasPerm(myposition,'all')) 
            ) {
                console.warn('Disabling presence pause due to lack of permissions');
                return false;
            } else {
                console.log('Enabling presence pause we have permission');
                return true;
            }
        },
        callback_queuemember: function(nro,texto,slot) {
            this.enableSelect();
        },
        callback_queuemembers: function(nro,texto,slot) {
            this.enableSelect();
        },
        callback_getvar: function(nro,texto,slot) {
            if(enable_pause_monitor==0) {
                return;
            }
            textodecoded = Base64.decode(texto);
            partes = textodecoded.split("~");
            pertes = partes[0].split("/");
            var entity = pertes[0];
            var pos = pertes[2];
            pertes = partes[1].split(":");
            var preason = pertes[0];
            var tstamp = pertes[1];

            if(entity=='PAUSECUSTOM') {
                if(preason=='ERROR' || preason=='') {
                    delete tiempos[`tick_pausedsince_pause${pos}`];
                    delete tiemposdirection[`tick_pausedsince_pause${pos}`];
                    $(`#paused-info-line-${pos}`).html('&nbsp;');
                } else {
                    tiempos[`tick_pausedsince_pause${pos}`]=parseInt(tstamp)*1000;
                    tiemposdirection[`tick_pausedsince_pause${pos}`]='UP';

                    if(lang[preason]!==undefined) {
                        reason = lang[preason];
                    } else {
                        reason = preason;
                    }

                    if ($(`#tick_pausedsince_pause${pos}`).length === 0) {
                        // Create the pause info line if it doesn't exist
                        if ($(`#paused-info-line-${pos}`).length === 0) {
                            $(`<div class="paused-info-line" id="paused-info-line-${pos}">
                                  <span id="tick_pausedsince_pause${pos}">00:00:00</span>
                                  <span class="pause-reason">${reason}</span>
                               </div>`).insertAfter(`#boton${pos} > .linewrapper:first`);
                        } else {
                            // Just update the timer if the line exists
                            $(`#tick_pausedsince_pause${pos}`).text('00:00:00');
                            //$(`#paused-info-line-${pos} .pause-reason`).text(reason);
                            $(`#paused-info-line-${pos}`).html(`<span id="tick_pausedsince_pause${pos}">00:00:00</span><span class="pause-reason">${reason}</span>`);
                        }
                    } else {
                        // Update the reason if timer already exists
                        //$(`#paused-info-line-${pos} .pause-reason`).text(reason);
                        $(`#paused-info-line-${pos}`).html(`<span id="tick_pausedsince_pause${pos}">00:00:00</span><span class="pause-reason">${reason}</span>`);
                    }

                }
            }
        },
        callback_presence: function(nro,texto,slot) {
            if(enable_pause_monitor==0) {
                return;
            }
            preason = Base64.decode(texto);
            let tDate = new Date();
            let tTime = tDate.getTime();

            if(preason=='ERROR' || preason=='') {
                delete tiempos[`tick_pausedsince_pause${nro}`];
                delete tiemposdirection[`tick_pausedsince_pause${nro}`];
                $(`#paused-info-line-${nro}`).html('&nbsp;');
            } else {
                tiempos[`tick_pausedsince_pause${nro}`]=tTime;
                tiemposdirection[`tick_pausedsince_pause${nro}`]='UP';

                if(lang[preason]!==undefined) {
                    reason = lang[preason];
                } else {
                    reason = preason;
                }

                let pos=nro;
                if ($(`#tick_pausedsince_pause${pos}`).length === 0) {
                    // Create the pause info line if it doesn't exist
                    if ($(`#paused-info-line-${pos}`).length === 0) {
                        $(`<div class="paused-info-line" id="paused-info-line-${pos}">
                              <span id="tick_pausedsince_pause${pos}">00:00:00</span>
                              <span class="pause-reason">${reason}</span>
                           </div>`).insertAfter(`#boton${pos} > .linewrapper:first`);
                    } else {
                        // Just update the timer if the line exists
                        $(`#tick_pausedsince_pause${pos}`).text('00:00:00');
                        //$(`#paused-info-line-${pos} .pause-reason`).text(reason);
                        $(`#paused-info-line-${pos}`).html(`<span id="tick_pausedsince_pause${pos}">00:00:00</span><span class="pause-reason">${reason}</span>`);
                    }
                } else {
                    // Update the reason if timer already exists
                    //$(`#paused-info-line-${pos} .pause-reason`).text(reason);
                    $(`#paused-info-line-${pos}`).html(`<span id="tick_pausedsince_pause${pos}">00:00:00</span><span class="pause-reason">${reason}</span>`);
                }
            }
        },
        callback_zbuttons: function(nro,texto,slot) {
            if(enable_pause_monitor==1) {
                for(i=0;i<buttontype.length;i++) {
                    if(buttontype[i]=='extension') {
                        if ($(`#paused-info-line-${i}`).length === 0) {
                            $(`<div class="paused-info-line" id="paused-info-line-${i}">&nbsp;</div>`).insertAfter(`#boton${i} > .linewrapper:first`);
                        }
                        send("<msg data=\"GENERAL|presencepausegetcustompause|" + i + "|\" />");
                    };
                }
            }
        },
        callback_notionline: function(nro,texto,slot) {
            if(availablequeues.length==0) {
                console.warn('Disabling presence pause due to no available queues');
                $('.navinputpresence').hide();
            } else {
                if(this.queuepause_permitted()) {
                    console.log('Enabling presence pause we have available queues');
                    $('.navinputpresence').show();
                }
            }
        },
        enableSelect: function() {
            let agent_channels = {}
            let all_channels = {};
            botonitos[myposition].QUEUECHANNEL.split('&').forEach(function(el) { agent_channels[el.split('|')[0]]=1;});
            Object.entries(queuesismember).forEach(function(el) { el[1].forEach( function(al){ all_channels[al]=1})});
            if(plugins['presencepause'].checkIntersect(agent_channels,all_channels)) {
                $('#presence').removeAttr('disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            } else {
                $('#presence').attr('disabled','disabled');
                $('#presence.selectpicker').selectpicker('refresh');
            }
        },
        checkIntersect: function(object1,object2) {
            for (let key in object1) {
                if (object2.hasOwnProperty(key)) {
                    return true;
                }
            }
            return false;
        }
    }
}());
